.386
.MODEL FLAT, STDCALL
OPTION CASEMAP:NONE


;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                                  I N C L U D E   F I L E S
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

INCLUDE \masm32\include\windows.inc
INCLUDE \masm32\include\kernel32.inc
INCLUDE \masm32\include\user32.inc

INCLUDELIB \masm32\lib\kernel32.lib
INCLUDELIB \masm32\lib\user32.lib


;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                                         D A T A
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
.DATA?

hDesktop    HWND ?

.DATA

hProgman    HWND 0
hDefView    HWND 0
hListView   HWND 0

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                                         C O D E
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
.CODE

szProgman   db "Progman",0
szDefView   db "SHELLDLL_DefView",0
szListView  db "SysListView32",0


;
; EnumCallback
;

EnumCallback PROC hWnd:HWND, lParam:LPARAM
  LOCAL szClass[64]:BYTE

  invoke  GetClassName, hWnd, ADDR szClass, SIZEOF szClass

  cmp     hProgman, 0
  je      Enum_Progman
  cmp     hDefView, 0
  je      Enum_DefView
  cmp     hListView, 0
  je      Enum_ListView
  jmp     Enum_Exit

Enum_Progman:
  cmp     eax, 7
  jne     Enum_Exit
  invoke  lstrcmp, ADDR szClass, ADDR szProgman
  test    eax, eax
  jnz     Enum_Exit

  invoke  GetAncestor, hWnd, GA_PARENT
  cmp     hDesktop, eax
  jne     Enum_Exit

  mov     eax, hWnd
  mov     hProgman, eax
  jmp     Enum_Exit

Enum_DefView:
  cmp     eax, 16
  jne     Enum_Exit
  invoke  lstrcmp, ADDR szClass, ADDR szDefView
  test    eax, eax
  jnz     Enum_Exit

  invoke  GetAncestor, hWnd, GA_PARENT
  cmp     hProgman, eax
  jne     Enum_Exit

  mov     eax, hWnd
  mov     hDefView, eax
  jmp     Enum_Exit

Enum_ListView:
  cmp     eax, 13
  jne     Enum_Exit
  invoke  lstrcmp, ADDR szClass, ADDR szListView
  test    eax, eax
  jnz     Enum_Exit

  invoke  GetAncestor, hWnd, GA_PARENT
  cmp     hDefView, eax
  jne     Enum_Exit

  mov     eax, hWnd
  mov     hListView, eax

Enum_Exit:
  mov     eax, 1
  ret
EnumCallback ENDP


;
; EntryPoint
;

EntryPoint:
  invoke  GetDesktopWindow
  mov     hDesktop, eax

  invoke  EnumChildWindows, hDesktop, ADDR EnumCallback, 0
  cmp     hListView, 0
  je      EP_Exit

  invoke  GetWindowLong, hListView, GWL_STYLE
  and     eax, NOT LVS_TYPEMASK
  
  ; NOTE:
  ;   LVS_NOSCROLL is not compatible with LVS_LIST or LVS_REPORT
  ;   So it *must* be disabled (NAND'ed) if using any of these two styles
  ;   It should be enabled (OR'ed) if using LVS_ICON or LVS_SMALLICON

  ; Details view
  and     eax, NOT LVS_NOSCROLL
  or      eax, LVS_REPORT

  ; Default view (large icons)
  ;or      eax, LVS_ICON OR LVS_NOSCROLL
  
  invoke  SetWindowLong, hListView, GWL_STYLE, eax

EP_Exit:
  invoke  ExitProcess, 0


;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
END EntryPoint
